//Működés:    (Redonyvezerles_04 kiegészítése)

//Program indításakor a redőny teljesen leengedésre kerül.
//Bármelyik gombot megnyomjuk, a redőny az adott irányba elindul,
//és a végállásig halad.
//Ha közben bármelyik gombot megnyomjuk a redőny megáll.
//Ismételt gombnyomásra ismét elindul az adott irányba a végállásig.
//A program elektronikusan is biztosítja a két gomb reteszelését.
//*****************
//A felfelé gomb 3 mp folyamatos nyomva tartása után a redőny a
//gomb elengedéséig megy. Ezt az időt megjegyzi a program és ez
//lesz az új felhúzási idő.
//A programozás és programozott felhúzás csak az alsó pozícióból működik!
//*****************
//Programozott felhúzás után az ismételt gombnyomás(felfelé) a végállásig teker.
//A redőny időben(msec) mért pontos pozíciója segítségével a végállások
//elektronikusan is be vannak állítva.
//A millis() értékének átfordulása esetén a program újraindul (kb.50 nap)
//A programozott érték és a tényleges pozíció eltárolásra kerül az EEPROM-ban.
//A program indításakor, valamint RESET esetén a redőny beállása az
//eltárolt pozícióba történik.
//*****************
//A kijelzéssel kapcsolatos utasítások, valamint a 13-as pin használata
//csak ellenőrzéshez, hibakereséshez szükségesek

#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <EEPROM.h>

unsigned long ora_gombok1 = 0;    //gombok figyeléséhez (20 msec)
unsigned long ora_gombok2 = 0;    //gombok figyeléséhez (20 msec)
int fel = HIGH;                   //felfele gomb állapota
int le = HIGH;                    //lefele gomb állapota
int fel_1 = 0;                    //gombnyomás érzékelése csak egyszer
int le_1 = 0;                     //gombnyomás érzékelése csak egyszer
boolean felfele=false;            //felfelé tekerés engedélyezése
boolean lefele=false;             //lefelé tekerés engedélyezése
boolean futasido=false;           //gombok nyomvatartási idejének figyelése
unsigned long ora_futasido = 0;   //programozó üzemmódhoz
unsigned long ora_futasido1 = 0;  //programozó üzemmódhoz
unsigned long ora_relay1 = 0;     //felfele tekerés időzítéséhez
unsigned long ora_relay2 = 0;     //lefele tekerés időzítéséhez
unsigned int felhuzasi_ido=10000; //a redőny teljes fel- és leengedéséhez szükséges idő
unsigned long start_fel=0;        //stopper a felfelé pozíció meghatározásájoz(start)
unsigned long vege_fel=0;         //stopper a felfelé pozíció meghatározásájoz(stop)
unsigned int eltelt_ido_fel=0;    //indítástól megállásig eltelt idő (felfelé)
unsigned long start_le=0;         //stopper a lefelé pozíció meghatározásájoz(start)
unsigned long vege_le=0;          //stopper a lefelé pozíció meghatározásájoz(stop)
unsigned int eltelt_ido_le=0;     //indítástól megállásig eltelt idő (lefelé)
long pozicio=0;                   //a redőny pontos helyzete(msec)
unsigned int felhuzas_idozitese=0;//tényleges felfelé tekerés időtartama(program, vagy végállás)
void (* ujrainditas) (void)=0;    //szoftveres reset

LiquidCrystal_I2C lcd(0x27,2,1,0,4,5,6,7,3,POSITIVE);
//****************************************************************
void setup() {
  pinMode(5, INPUT);
  pinMode(6, INPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);
  pinMode(13, OUTPUT);
  lcd.begin (16,2);
  lcd.backlight();
  //********************
  //Program indításakor a redőny teljesen leengedésre kerül.
  digitalWrite(8, HIGH);
  delay(felhuzasi_ido); //a millis() fügvény átfordulása miatt is szükséges
  digitalWrite(8, LOW);
  eepromread();         //eltárolt értékek beolvasása
  if (pozicio!=0){
    digitalWrite(7, HIGH);
    delay(pozicio);
    digitalWrite(7, LOW);
    }
}
//****************************************************************
void loop() {
  gombok();               //gombnyomás figyelés
  futasido_figyeles();    //program módba belépéshez(3 sec után)
  futasi_ido_szamitas();  //pozíció számítás
  relay();
  kijelzes();
  szamlalo_atfordulas();  //millis() számláló átfordulásának figyelése
}
//****************************************************************
void eepromread(){    //eltárolt értékek kiolvasása EEPROM-ból
  if (EEPROM.read(0) == 200){
    felhuzasi_ido = EEPROM.read(1)*1000+EEPROM.read(2)*100+EEPROM.read(3)*10+EEPROM.read(4);
    pozicio = EEPROM.read(5)*1000+EEPROM.read(6)*100+EEPROM.read(7)*10+EEPROM.read(8);
    }
}
//********************
void eepromwrite_felhuzasi_ido(){     //programozott felhúzás eltárolása
  EEPROM.write(1,felhuzasi_ido/1000);
  EEPROM.write(2,felhuzasi_ido%1000/100);
  EEPROM.write(3,felhuzasi_ido%1000%100/10);
  EEPROM.write(4,felhuzasi_ido%1000%100%10);
  EEPROM.write(0, 200);     //ellenörzéshez
}
//********************
void eepromwrite_pozicio(){           //pozíció eltárolása
  EEPROM.write(5,pozicio/1000);
  EEPROM.write(6,pozicio%1000/100);
  EEPROM.write(7,pozicio%1000%100/10);
  EEPROM.write(8,pozicio%1000%100%10);
  EEPROM.write(0, 200);     //ellenörzéshez 
}
//****************************************************************
void gombok(){
  ora_gombok1 = millis();               //20 msec időközönként ellenörzi a nyomógomb állapotát
  if (ora_gombok1 - ora_gombok2 > 20){  //és engedélyezi a program végrehajtását
    ora_gombok2 = ora_gombok1; 
    //program 
    fel = digitalRead(5);
    if (fel==HIGH) fel_1=1;    //Ez a rész csak egyszer engedi a
    if (fel==LOW & fel_1==1){  //következő utasításokat végrehajtani,
       fel_1=0;                //függetlenül a nyomva tartás idejétől.
       //program
       if ((pozicio<10000)||(digitalRead(8)==HIGH)) felfele=true;
          //a pozicio figyelése szükséges, hogy a felső végállás után rövid időre se
          //engedje (20 msec) az újbóli felfelé kapcsolást. A kimenet figyelése lehetővé teszi,
          //hogy felső végállásból a lefelé tekerést a felfelé gomb is le tudja állítani.
       }
    le = digitalRead(6);
    if (le==HIGH) le_1=1;     //Ez a rész csak egyszer engedi a 
    if (le==LOW & le_1==1){   //következő utasításokat végrehajtani,
       le_1=0;                //függetlenül a nyomva tartás idejétől.
       //program
       if ((pozicio>0)||(digitalRead(7)==HIGH)) lefele=true;
          //a pozicio figyelése szükséges, hogy az alsó végállás után rövid időre se
          //engedje (20 msec) az újbóli lefelé kapcsolást. A kimenet figyelése lehetővé teszi,
          //hogy alsó végállásból a felfelé tekerést a lefelé gomb is le tudja állítani.
       }
    }
}
//****************************************************************
void futasido_figyeles(){   //program módba belépéshez(3 sec után)
  if ((ora_futasido==0)&&(fel==LOW)) ora_futasido=millis();
  if (fel==HIGH) ora_futasido=0;
    
  //3 mp után programozói módba kapcsol, ha a redőny lentről indul(pozicio=0)    
  if ((millis()>(ora_futasido + 3000))&&(fel==LOW)&&(pozicio==0)){
    futasido=true;
    felhuzasi_ido=10000; //program módban végállásig menjen
    }
  if ((futasido==true)&&(ora_futasido1==0)) ora_futasido1=millis();
  if ((fel==HIGH)&&(futasido==true)){
    digitalWrite(7, LOW);
    //digitalWrite(13,HIGH);  //csak hibakereséshez
    felhuzasi_ido=(millis()-ora_futasido1)+3000;
    eepromwrite_felhuzasi_ido();    //EEPROM-ba írás
    digitalWrite(13,HIGH);
    delay(5);
    digitalWrite(13,LOW);
    ora_futasido1=0;
    futasido=false;
    }
}    
//****************************************************************
void relay(){   //relék vezérlése
  //bármelyik gomb megnyomása megállítja a redőnyt
  if ((digitalRead(7)==HIGH || digitalRead(8)==HIGH)&&(felfele==true || lefele==true)){
    digitalWrite(7, LOW);
    digitalWrite(8, LOW);
    //digitalWrite(13,LOW);
    felfele=false;
    lefele=false;
    ora_relay1=0;
    ora_relay2=0;
    }
  //*************************
  if (digitalRead(8)==LOW){ //elektronikus reteszeléshez
    if (felfele==true){
      digitalWrite(7, HIGH);
      felfele=false;
      ora_relay1=0;
      }
    if (ora_relay1==0){   
      ora_relay1=millis();
      }
    if (pozicio==0){                          //ha lentről indul, akkor a program
      felhuzas_idozitese=felhuzasi_ido;       //idejéig megy, ellenkező esetben
      }else felhuzas_idozitese=10000-pozicio; //a fenti végállásig
    if (millis()>(ora_relay1 + felhuzas_idozitese)){
      digitalWrite(7, LOW);
      ora_relay1=0;
      }
    } else felfele=false;     //elektronikus reteszeléshez
  //*************************
  if (digitalRead(7)==LOW){  //elektronikus reteszeléshez
    if (lefele==true){
      digitalWrite(8, HIGH);
      lefele=false;
      ora_relay2=0;
      }
    if (ora_relay2==0){   
      ora_relay2=millis();
      }
    if (millis()>(ora_relay2 + pozicio)){
      digitalWrite(8, LOW);
      ora_relay2=0;
      }
    } else lefele=false;  //elektronikus reteszeléshez
}
//****************************************************************
void futasi_ido_szamitas(){   //pozíció meghatározása
  //felfele
  if ((digitalRead(7)==HIGH)&&(start_fel==0)){    //stopper start
    start_fel=millis();
    } else if((digitalRead(7)==LOW)&&(start_fel!=0)){ //stopper stop
        vege_fel=millis();
        eltelt_ido_fel=vege_fel-start_fel;    //msec
        pozicio=pozicio+eltelt_ido_fel;
        if (pozicio>10000) pozicio=10000;   //túlcsordulás miatt(fent)
        start_fel=0;
        eepromwrite_pozicio();
        digitalWrite(13,HIGH);
        delay(5);
        digitalWrite(13,LOW);
        lcd.clear();
        }
  //lefele **********************
  if ((digitalRead(8)==HIGH)&&(start_le==0)){   //stopper start
    start_le=millis();
    } else if((digitalRead(8)==LOW)&&(start_le!=0)){  //stopper stop
        vege_le=millis();
        eltelt_ido_le=vege_le-start_le;    //msec
        pozicio=pozicio-eltelt_ido_le;
        if (pozicio<0) pozicio=0;   //túlcsordulás miatt(lent)
        start_le=0;
        eepromwrite_pozicio();
        digitalWrite(13,HIGH);
        delay(5);
        digitalWrite(13,LOW);
        lcd.clear();
        }
}
//****************************************************************
void kijelzes(){
  lcd.setCursor (0,0);
  lcd.print("Fel:");
  lcd.print(eltelt_ido_fel/1000.0,1);
  lcd.setCursor (9,0);
  lcd.print("Le:");
  lcd.print(eltelt_ido_le/1000.0,1);
  lcd.setCursor (0,1);
  lcd.print("Pozicio:");
  lcd.print(pozicio/1000.0,1);
  lcd.print(" sec");
}
//****************************************************************
void szamlalo_atfordulas(){  //számláló átfordulásának figyelése - millis()
  if(millis()<3000) ujrainditas();    //reset
}
//****************************************************************
